## stella 6.7.1%2Bdfsg

=== src/libretro/Makefile ===
DEBUG = 0
HAVE_EXCEPTIONS = 1
HAVE_STRINGS_H = 1

LTO ?= -flto
SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
   platform = unix
   ifeq ($(shell uname -s),)
      platform = win
   else ifneq ($(findstring MINGW,$(shell uname -s)),)
      platform = win
   else ifneq ($(findstring Darwin,$(shell uname -s)),)
      platform = osx
      arch = intel
      ifeq ($(shell uname -p),powerpc)
         arch = ppc
      endif
      ifeq ($(shell uname -p),arm)
         arch = arm
      endif
   else ifneq ($(findstring win,$(shell uname -s)),)
      platform = win
   endif
else ifneq (,$(findstring armv,$(platform)))
   ifeq (,$(findstring classic_,$(platform)))
      override platform += unix
   endif
else ifneq (,$(findstring rpi,$(platform)))
   override platform += unix
endif

ifneq ($(platform), osx)
   ifeq ($(findstring Haiku,$(shell uname -a)),)
      PTHREAD_FLAGS = -lpthread
   endif
endif

TARGET_NAME = stella


ifeq (,$(findstring msvc,$(platform)))
   CXXFLAGS += -std=c++17 -fno-rtti
   LIBS := -lm
else
   LIBS :=
endif

GIT_VERSION := " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
   CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

GET_STATIC_ARG=$(if $(filter $(shell $(CXX) -print-file-name=$1.a),$1.a),,-static-$1)
# Unix
ifneq (,$(findstring unix,$(platform)))
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) $(call GET_STATIC_ARG,libgcc) $(call GET_STATIC_ARG,libstdc++)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   ifneq ($(findstring SunOS,$(shell uname -a)),)
      CXX = g++
      SHARED := -shared -z defs
   else
      SHARED := -shared -Wl,--version-script=link.T -Wl,-z,defs
   endif

   # ARM
   ifneq (,$(findstring armv,$(platform)))
      CXXFLAGS += -DARM
   # Raspberry Pi
   else ifneq (,$(findstring rpi,$(platform)))
      CXXFLAGS += -DARM
   endif

# OS X
else ifeq ($(platform), osx)
   CXXFLAGS += $(LTO) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION :=
   arch = intel
   ifeq ($(shell uname -p),powerpc)
      arch = ppc
   endif
   ifeq ($(arch),ppc)
      CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   endif
   OSXVER = $(shell sw_vers -productVersion | cut -d. -f 2)
   OSX_GT_MOJAVE = $(shell (( $(OSXVER) >= 14)) && echo "YES")
   ifneq ($(OSX_GT_MOJAVE),YES)
      #this breaks compiling on Mac OS Mojave
      MINVERSION = -mmacosx-version-min=10.7
   endif
   fpic += $(MINVERSION)

   ifeq ($(CROSS_COMPILE),1)
		TARGET_RULE   = -target $(LIBRETRO_APPLE_PLATFORM) -isysroot $(LIBRETRO_APPLE_ISYSROOT)
		CFLAGS   += $(TARGET_RULE)
		CPPFLAGS += $(TARGET_RULE)
		CXXFLAGS += $(TARGET_RULE)
		LDFLAGS  += $(TARGET_RULE)
   endif

   CFLAGS    += $(ARCHFLAGS)
   CXXFLAGS  += $(ARCHFLAGS)
   LDFLAGS   += $(ARCHFLAGS)

# iOS
else ifneq (,$(findstring ios,$(platform)))
   CXXFLAGS += $(LTO) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION :=
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
   endif
   ifeq ($(platform),ios-arm64)
      CC  = cc -arch arm64 -isysroot $(IOSSDK)
      CXX = c++ -arch arm64 -isysroot $(IOSSDK)
   else
      CC  = cc -arch armv7 -isysroot $(IOSSDK)
      CXX = c++ -arch armv7 -isysroot $(IOSSDK)
   endif
   CXXFLAGS += -DIOS -DARM -fno-aligned-allocation
   ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
      MINVERSION = -miphoneos-version-min=8.0
   else
      MINVERSION = -miphoneos-version-min=5.0
   endif
   CXXFLAGS += $(MINVERSION)

# tvOS
else ifeq ($(platform), tvos-arm64)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
   endif
   CXXFLAGS += -DIOS
   CXXFLAGS += -DARM

   CC  = cc -arch arm64 -isysroot $(IOSSDK)
   CXX = c++ -arch arm64 -isysroot $(IOSSDK)

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
   include $(DEVKITPRO)/libnx/switch_rules
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   DEFINES := -DSWITCH=1 -D__SWITCH__ -DARM
   CXXFLAGS += $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
   CXXFLAGS += -march=armv8-a -mtune=cortex-a57 -mtp=soft -mcpu=cortex-a57+crc+fp+simd -ffast-math $(ASFLAGS)
   STATIC_LINKING = 1

# Classic Platforms ####################
# Platform affix = classic_<ISA>_<µARCH>
# Help at https://modmyclassic.com/comp

# (armv7 a7, hard point, neon based) ###
# NESC, SNESC, C64 mini
else ifeq ($(platform), classic_armv7_a7)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CXXFLAGS += -Ofast \
               -flto=4 -fwhole-program -fuse-linker-plugin \
               -fdata-sections -ffunction-sections -Wl,--gc-sections \
               -fno-stack-protector -fno-ident -fomit-frame-pointer \
               -falign-functions=1 -falign-jumps=1 -falign-loops=1 \
               -fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
               -fmerge-all-constants -fno-math-errno \
              -marm -mtune=cortex-a7 -mfpu=neon-vfpv4 -mfloat-abi=hard
   HAVE_NEON = 1
   ARCH = arm
   BUILTIN_GPU = neon
   USE_DYNAREC = 1
   ifeq ($(shell echo `$(CXX) -dumpversion` "< 4.9" | bc -l), 1)
      CXXFLAGS += -march=armv7-a
   else
      CXXFLAGS += -march=armv7ve
      # If gcc is 5.0 or later
      ifeq ($(shell echo `$(CXX) -dumpversion` ">= 5" | bc -l), 1)
         LDFLAGS += -static-libgcc -static-libstdc++
      endif
   endif


# Theos
else ifeq ($(platform), theos_ios)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   DEPLOYMENT_IOSVERSION = 5.0
   TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
   ARCHS = armv7 armv7s
   TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
   THEOS_BUILD_DIR := objs
   include $(THEOS)/makefiles/common.mk
   LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   CXX = QCC -Vgcc_notarmv7le
   AR = QCC -Vgcc_ntoarmv7le
   CXXFLAGS += -D__BLACKBERRY_QNX__
   CXXFLAGS += -DARM
   HAVE_EXCEPTIONS = 1

# Vita
else ifeq ($(platform), vita)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   CXX = arm-vita-eabi-g++$(EXE_EXT)
   AR = arm-vita-eabi-ar$(EXE_EXT)
   CXXFLAGS += -DVITA
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   HAVE_EXCEPTIONS = 1

# PS3
else ifneq (,$(filter $(platform), ps3 sncps3 psl1ght))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   STATIC_LINKING = 1
   HAVE_STRINGS_H = 0

   # sncps3
   ifneq (,$(findstring sncps3,$(platform)))
      TARGET := $(TARGET_NAME)_libretro_ps3.a
      CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
      AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
   # PS3
   else ifneq (,$(findstring ps3,$(platform)))
      CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
      AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
   # Lightweight PS3 Homebrew SDK
   else ifneq (,$(findstring psl1ght,$(platform)))
      CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
      AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   endif

# CTR (3DS)
else ifeq ($(platform), ctr)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITARM)/bin/arm-none-eabi-g++$(EXE_EXT)
   AR = $(DEVKITARM)/bin/arm-none-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES := -DLSB_FIRST
   CXXFLAGS += -DARM11 -D_3DS
   CXXFLAGS += -march=armv6k -mtune=mpcore -mfloat-abi=hard
   CXXFLAGS += -mword-relocations
   CXXFLAGS += -fomit-frame-pointer -fstrict-aliasing -ffast-math
   CXXFLAGS += -fno-rtti
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1
   LOAD_FROM_MEMORY = 0

# Xbox 360
else ifeq ($(platform), xenon)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   CXXFLAGS += -D__LIBXENON__ -m32 -D__ppc__
   LIBS := $(PTHREAD_FLAGS)
   STATIC_LINKING = 1

# Nintendo Game Cube / Wii / WiiU
else ifneq (,$(filter $(platform), ngc wii wiiu))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   CXXFLAGS += -mcpu=750 -meabi -mhard-float -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1

   # Nintendo WiiU
   ifneq (,$(findstring wiiu,$(platform)))
      CXXFLAGS += -mwup
   # Nintendo Wii
   else ifneq (,$(findstring wii,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   # Nintendo Game Cube
   else ifneq (,$(findstring ngc,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   endif

# Emscripten
else ifeq ($(platform), emscripten)
   TARGET := $(TARGET_NAME)_libretro_$(platform).bc
   STATIC_LINKING = 1
   CXXFLAGS += $(PTHREAD_FLAGS) -std=c++17
   LDFLAGS += $(PTHREAD_FLAGS) -std=c++17

# Genode
else ifeq ($(platform), genode)
   TARGET  := $(TARGET_NAME)_libretro.lib.so
   PKG_CONFIG := genode-lib genode-stdcxx
   CXXFLAGS += -D__GENODE__
   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))

   LDFLAGS += -shared --version-script=link.T
   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))

   CXX = $(shell pkg-config genode-base --variable=cxx)
   LD  = $(shell pkg-config genode-base --variable=ld)
   AR  = $(shell pkg-config genode-base --variable=ar) -rcs

# Windows MSVC 2003 Xbox 1
else ifeq ($(platform), xbox1_msvc2003)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk1.lib
   MSVCBINDIRPREFIX = $(XDK)/xbox/bin/vc71
   CXX  = "$(MSVCBINDIRPREFIX)/CL.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XDK)/xbox/include
   export LIB := $(XDK)/xbox/lib
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX1
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2010 Xbox 360
else ifeq ($(platform), xbox360_msvc2010)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk360.lib
   MSVCBINDIRPREFIX = $(XEDK)/bin/win32
   CXX  = "$(MSVCBINDIRPREFIX)/cl.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XEDK)/include/xbox
   export LIB := $(XEDK)/lib/xbox
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX360
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2017 all architectures
else ifneq (,$(findstring windows_msvc2017,$(platform)))
   CXXFLAGS += -D__WIN32__

   PlatformSuffix = $(subst windows_msvc2017_,,$(platform))
   ifneq (,$(findstring desktop,$(PlatformSuffix)))
      WinPartition = desktop
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_DESKTOP_APP
      LDFLAGS += -MANIFEST -LTCG:incremental -NXCOMPAT -DYNAMICBASE -DEBUG -OPT:REF -INCREMENTAL:NO -SUBSYSTEM:WINDOWS -MANIFESTUAC:"level='asInvoker' uiAccess='false'" -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1
      LIBS += kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib
   else ifneq (,$(findstring uwp,$(PlatformSuffix)))
      WinPartition = uwp
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_APP -D_WINDLL -D_UNICODE -DUNICODE -D__WRL_NO_DEFAULT_LIB__ -ZW:nostdlib -EHsc
      LDFLAGS += -APPCONTAINER -NXCOMPAT -DYNAMICBASE -MANIFEST:NO -LTCG -OPT:REF -SUBSYSTEM:CONSOLE -MANIFESTUAC:NO -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1 -DEBUG:FULL -WINMD:NO

## stella 6.7.1+dfsg

=== debian/changelog ===
stella (6.7.1+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:04:16 +1100

stella (6.7.1+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 08:17:05 +0000

stella (6.7.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update Lintian override syntax.

 -- Stephen Kitt <skitt@debian.org>  Thu, 18 Jan 2024 16:29:41 +0100

=== debian/control ===
Source: stella
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen Kitt <skitt@debian.org>
Section: otherosfs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libpng-dev,
               libsdl2-dev,
               libsqlite3-dev,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/games-team/stella
Vcs-Git: https://salsa.debian.org/games-team/stella.git
Homepage: https://stella-emu.github.io
Rules-Requires-Root: no

Package: stella
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: joystick (>= 1:1.5.1)
Pre-Depends: ${misc:Pre-Depends}
Description: Atari 2600 Emulator for SDL & the X Window System
 Stella is a portable emulator of the old Atari 2600 video-game
 console. You can play most Atari 2600 games with it.
 .
 Stella's features include:
  * emulation of Atari 2600 joysticks, keyboards, paddles and driving
    controllers using the host system's input peripherals;
  * emulation of trackballs, joysticks, booster grips, driving
    controllers and the Amiga Mouse using the host system's mouse;
  * support for real Atari 2600 controllers using the Stelladaptor,
    2600-daptor or 2600-daptor II;
  * support for real Atari 7800 controllers using the 2600-daptor II;
  * support for the speech portion of a real AtariVox device;
  * support for Supercharger single-load and multi-load games;
  * emulation of CRT TV features, including texturing, colour bleed,
    RF noise and phosphor burn-off (requires OpenGL).
 .
 An extensive debugger is included, with the Distella disassembler.
 .
 Note that this is not isee systems' STELLA modeling, simulation and
 analysis tool.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
DPKG_EXPORT_BUILDTOOLS=1
-include /usr/share/dpkg/buildtools.mk

%:
	dh $@

override_dh_auto_clean:
# Generate the minimal config.mak required for "make distclean"
	test -f config.mak || echo "RM_REC := rm -f -r" > config.mak
	dh_auto_clean

override_dh_auto_configure:
	./configure --prefix=/usr $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,--host=$(DEB_HOST_GNU_TYPE)) --enable-release

override_dh_auto_install:
	dh_auto_install
	# This is also installed as the upstream changelog
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/Changes.txt
	# This is overridden by the copyright file
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/License.txt

=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%stella-$1.tar.gz%" \
    https://github.com/stella-emu/stella/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## stella 7.0+dfsg

=== Makefile ===
##============================================================================
##
##   SSSS    tt          lll  lll
##  SS  SS   tt           ll   ll
##  SS     tttttt  eeee   ll   ll   aaaa
##   SSSS    tt   ee  ee  ll   ll      aa
##      SS   tt   eeeeee  ll   ll   aaaaa  --  "An Atari 2600 VCS Emulator"
##  SS  SS   tt   ee      ll   ll  aa  aa
##   SSSS     ttt  eeeee llll llll  aaaaa
##
## Copyright (c) 1995-2024 by Bradford W. Mott, Stephen Anthony
## and the Stella Team
##
## See the file "License.txt" for information on usage and redistribution of
## this file, and for a DISCLAIMER OF ALL WARRANTIES.
##============================================================================

#######################################################################
# Default compilation parameters. Normally don't edit these           #
#######################################################################

srcdir      ?= .

DEFINES     := -DSDL_SUPPORT -D_GLIBCXX_USE_CXX11_ABI=1
LDFLAGS     := -pthread
INCLUDES    :=
LIBS	    :=
OBJS	    :=
OBJS_TEST :=
PROF        :=

MODULES     :=
MODULE_DIRS :=

DISTNAME    := stella-snapshot

# Load the make rules generated by configure
include config.mak

# Uncomment this for stricter compile time code verification
# CXXFLAGS+= -Werror

ifdef CXXFLAGS
  CFLAGS:= $(CXXFLAGS)
  CXXFLAGS:= $(CXXFLAGS) -x c++
else
  CXXFLAGS:= -O2 -x c++
  CFLAGS:= -O2
endif

ifndef CXXFLAGS_TEST
	CXXFLAGS_TEST := $(CXXFLAGS)
endif

ifndef CFLAGS_TEST
	CFLAGS_TEST := $(CFLAGS)
endif

ifndef LDFLAGS_TEST
	LDFLAGS_TEST := $(LDFLAGS)
endif

CXXFLAGS+= -Wall -Wextra -Wno-unused-parameter
CFLAGS+= -Wall -Wextra -Wno-unused-parameter

CXXFLAGS_TEST+= -Wall -Wextra -Wno-unused-parameter
CFLAGS_TEST+= -Wall -Wextra -Wno-unused-parameter

ifdef HAVE_GCC
  CXXFLAGS+= -Wno-multichar -Wunused -Woverloaded-virtual -std=c++20
  CFLAGS+= -Wunused

  CXXFLAGS_TEST+= -Wno-multichar -Wunused -Woverloaded-virtual -std=c++20
  CFLAGS_TEST+= -Wno-multichar -Wunused
endif

ifdef HAVE_CLANG
  CXXFLAGS+= -Wunused -Woverloaded-virtual -std=c++20
  CFLAGS+= -Wunused

  CXXFLAGS_TEST+= -Wno-multichar -Wunused -Woverloaded-virtual -std=c++20
  CFLAGS_TEST+= -Wno-multichar -Wunused
endif

ifdef CLANG_WARNINGS
  EXTRA_WARN=-Wno-c++98-compat-pedantic -Wno-undefined-func-template \
    -Wno-switch-enum -Wno-conversion -Wno-covered-switch-default \
    -Wno-documentation -Wno-float-equal \
    -Wno-exit-time-destructors -Wno-global-constructors -Wno-weak-vtables \
    -Wno-four-char-constants -Wno-padded -Wno-reserved-identifier \
    -Wno-duplicate-enum -Wno-unsafe-buffer-usage

  CXXFLAGS+= $(EXTRA_WARN)
  CFLAGS+= $(EXTRA_WARN)

	CXXFLAGS_TEST+= $(EXTRA_WARN)
  CFLAGS_TEST+= $(EXTRA_WARN)
endif

ifdef PROFILE
  PROF:= -pg -fprofile-arcs -ftest-coverage
  CXXFLAGS+= $(PROF)
  CFLAGS+= $(PROF)
endif

ifdef DEBUG
  CXXFLAGS += -g -Wp,-D_GLIBCXX_DEBUG
  CFLAGS += -g -Wp,-D_GLIBCXX_DEBUG
else
  ifdef HAVE_GCC
    CXXFLAGS+= -fomit-frame-pointer
    CFLAGS+= -fomit-frame-pointer
  endif

  ifdef HAVE_CLANG
    CXXFLAGS+= -fomit-frame-pointer
    CFLAGS+= -fomit-frame-pointer
  endif
endif

ifdef RELEASE
  CXXFLAGS += -flto -fno-rtti
  CFLAGS += -flto
  LDFLAGS += -flto -fno-rtti
endif

#######################################################################
# Misc stuff - you should never have to edit this                     #
#######################################################################

ifdef STELLA_BUILD_ROOT
  OBJECT_ROOT := $(STELLA_BUILD_ROOT)/stella-out
else
  OBJECT_ROOT := out
endif
OBJECT_ROOT_TEST := out.test
OBJECT_ROOT_PROFILE_GENERERATE := out.pgen
OBJECT_ROOT_PROFILE_USE := out.pgo

EXECUTABLE := stella$(EXEEXT)
EXECUTABLE_PROFILE_GENERATE := stella-pgo-generate$(EXEEXT)
EXECUTABLE_PROFILE_USE := stella-pgo$(EXEEXT)
EXECUTABLE_TEST := stella-test$(EXEEXT)

PROFILE_DIR = $(CURDIR)/test/roms/profile
PROFILE_OUT = $(PROFILE_DIR)/out
PROFILE_STAMP = profile.stamp

CXXFLAGS_PROFILE_GENERATE = $(CXXFLAGS)
CXXFLAGS_PROFILE_USE = $(CXXFLAGS)
CFLAGS_PROFILE_GENERATE = $(CFLAGS)
CFLAGS_PROFILE_USE = $(CFLAGS)
LDFLAGS_PROFILE_GENERATE = $(LDFLAGS)
STELLA_PROFILE_GENERATE = $(BINARY_LOADER) ./$(EXECUTABLE_PROFILE_GENERATE) -profile \
	$(PROFILE_DIR)/128.bin:10 \
	$(PROFILE_DIR)/catharsis_theory.bin:60

ifdef HAVE_CLANG
	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
	CXXFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
	CFLAGS_PROFILE_GENERATE += -fprofile-generate=$(PROFILE_OUT)
	CFLAGS_PROFILE_USE += -fprofile-use=$(PROFILE_OUT)
	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
	STELLA_PROFILE_GENERATE := \
		LLVM_PROFILE_FILE="$(PROFILE_OUT)/default.profraw" $(STELLA_PROFILE_GENERATE) && \
		$(LLVM_PROFDATA) merge -o $(PROFILE_OUT)/default.profdata $(PROFILE_OUT)/default.profraw
endif

ifdef HAVE_GCC
	CXXFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
	CXXFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
	CFLAGS_PROFILE_GENERATE += -fprofile-generate -fprofile-dir=$(PROFILE_OUT)
	CFLAGS_PROFILE_USE += -fprofile-use -fprofile-dir=$(PROFILE_OUT)
	LDFLAGS_PROFILE_GENERATE += -fprofile-generate
	STELLA_PROFILE_GENERATE := $(STELLA_PROFILE_GENERATE) && \
	  (rm -fr $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) || true) && \
		(mv $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_GENERERATE) $(PROFILE_OUT)/$(OBJECT_ROOT_PROFILE_USE) || true)
endif

all: $(EXECUTABLE)

pgo: $(EXECUTABLE_PROFILE_USE)

test: $(EXECUTABLE_TEST)
	./$(EXECUTABLE_TEST)

######################################################################
# Various minor settings
######################################################################

# The name for the directory used for dependency tracking
DEPDIR := .deps


######################################################################
# Module settings
######################################################################

MODULES := $(MODULES)

# After the game specific modules follow the shared modules
MODULES += \
	src/common \
	src/common/audio \
	src/common/tv_filters \
	src/emucore \
	src/emucore/tia \
	src/emucore/tia/frame-manager \
	src/emucore/elf \
	src/common/repository/sqlite

######################################################################
# The build rules follow - normally you should have no need to
# touch whatever comes after here.
######################################################################

# Concat DEFINES and INCLUDES to form the CPPFLAGS
CPPFLAGS:= $(DEFINES) $(INCLUDES)

# Include the build instructions for all modules
-include $(addprefix $(srcdir)/, $(addsuffix /module.mk,$(MODULES)))

# Depdir information
DEPDIRS = $(addsuffix /$(DEPDIR),$(MODULE_DIRS))
DEPFILES =

OBJ=$(addprefix $(OBJECT_ROOT)/,$(OBJS))
OBJ_TEST=$(addprefix $(OBJECT_ROOT_TEST)/,$(OBJS_TEST))
OBJ_PROFILE_GENERATE=$(addprefix $(OBJECT_ROOT_PROFILE_GENERERATE)/,$(OBJS))
OBJ_PROFILE_USE=$(addprefix $(OBJECT_ROOT_PROFILE_USE)/,$(OBJS))

# The build rule for the Stella executable
$(EXECUTABLE): $(OBJ)
	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

$(EXECUTABLE_TEST): $(OBJ_TEST)
	$(LD) $(LDFLAGS_TEST) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) -lgtest -lgtest_main -o $@

$(EXECUTABLE_PROFILE_GENERATE): $(OBJ_PROFILE_GENERATE)
	$(LD) $(LDFLAGS_PROFILE_GENERATE) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

$(EXECUTABLE_PROFILE_USE): $(OBJ_PROFILE_USE)
	$(LD) $(LDFLAGS) $(PRE_OBJS_FLAGS) $+ $(POST_OBJS_FLAGS) $(LIBS) $(PROF) -o $@

distclean: clean
	$(RM_REC) $(DEPDIRS)
	$(RM) build.rules config.h config.mak config.log

clean:
	-$(RM) -fr \
		$(OBJECT_ROOT) $(OBJECT_ROOT_PROFILE_GENERERATE) $(OBJECT_ROOT_PROFILE_USE) \
		$(EXECUTABLE) $(EXECUTABLE_PROFILE_GENERATE) $(EXECUTABLE_PROFILE_USE) \
		$(OBJECT_ROOT_TEST) $(PROFILE_OUT) $(PROFILE_STAMP)

.PHONY: all clean dist distclean

.SUFFIXES: .cxx

define create_dir
$(MKDIR) -p $(*D)/$(DEPDIR)
$(MKDIR) -p $(@D)
endef

define merge_dep
$(ECHO) "$(*D)/" > $(*D)/$(DEPDIR)/$(*F).d
$(CAT) "$(*D)/$(DEPDIR)/$(*F).d2" >> "$(*D)/$(DEPDIR)/$(*F).d"
$(RM) "$(*D)/$(DEPDIR)/$(*F).d2"
endef

ifndef CXX_UPDATE_DEP_FLAG
# If you use GCC, disable the above and enable this for intelligent
# dependency tracking.
CXX_UPDATE_DEP_FLAG = -Wp,-MMD,"$(*D)/$(DEPDIR)/$(*F).d2"

$(OBJECT_ROOT)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_TEST) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_TEST)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_TEST) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_TEST)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.pgen.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.cxx $(PROFILE_STAMP)
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

$(OBJECT_ROOT_PROFILE_USE)/%.pgo.o: %.c $(PROFILE_STAMP)
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@
	$(merge_dep)

else
# If you even have GCC 3.x, you can use this build rule, which is safer; the above
# rule can get you into a bad state if you Ctrl-C at the wrong moment.
# Also, with this GCC inserts additional dummy rules for the involved headers,
# which ensures a smooth compilation even if said headers become obsolete.
$(OBJECT_ROOT)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_TEST)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_TEST) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_TEST)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_TEST) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.cxx
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_GENERERATE)/%.o: %.c
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_GENERATE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_USE)/%.o: %.cxx $(PROFILE_STAMP)
	$(create_dir)
	$(CXX) $(CXX_UPDATE_DEP_FLAG) $(CXXFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@

$(OBJECT_ROOT_PROFILE_USE)/%.o: %.c $(PROFILE_STAMP)
	$(create_dir)
	$(CC) $(CXX_UPDATE_DEP_FLAG) $(CFLAGS_PROFILE_USE) $(CPPFLAGS) -c $(<) -o $@

endif

# Include the dependency tracking files. We add /dev/null at the end
# of the list to avoid a warning/error if no .d file exist
-include $(wildcard $(addsuffix /*.d,$(DEPDIRS))) /dev/null

$(PROFILE_STAMP): $(EXECUTABLE_PROFILE_GENERATE)
	-rm -fr $(PROFILE_OUT)
	$(STELLA_PROFILE_GENERATE)
	touch $(PROFILE_STAMP)

# check if configure has been run or has been changed since last run
config.mak: $(srcdir)/configure
	@echo "You need to run ./configure before you can run make"
	@echo "Either you haven't run it before or it has changed."
	@exit 1

install: all
	$(INSTALL) -d "$(DESTDIR)$(BINDIR)"
	$(INSTALL) -c -m 755 "$(srcdir)/stella$(EXEEXT)" "$(DESTDIR)$(BINDIR)/stella$(EXEEXT)"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)"
	$(INSTALL) -c -m 644 "$(srcdir)/Announce.txt" "$(srcdir)/Changes.txt" "$(srcdir)/Copyright.txt" "$(srcdir)/License.txt" "$(srcdir)/README-SDL.txt" "$(srcdir)/README.md" "$(srcdir)/Todo.txt" "$(srcdir)/docs/index.html" "$(srcdir)/docs/debugger.html" "$(DESTDIR)$(DOCDIR)/"
	$(INSTALL) -d "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -c -m 644 $(wildcard $(srcdir)/docs/graphics/*.png) "$(DESTDIR)$(DOCDIR)/graphics"
	$(INSTALL) -d "$(DESTDIR)$(DATADIR)/applications"

=== src/os/libretro/Makefile ===
DEBUG = 0
HAVE_EXCEPTIONS = 1
HAVE_STRINGS_H = 1

LTO ?= -flto
SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
   platform = unix
   ifeq ($(shell uname -s),)
      platform = win
   else ifneq ($(findstring MINGW,$(shell uname -s)),)
      platform = win
   else ifneq ($(findstring Darwin,$(shell uname -s)),)
      platform = osx
      arch = intel
      ifeq ($(shell uname -p),powerpc)
         arch = ppc
      endif
      ifeq ($(shell uname -p),arm)
         arch = arm
      endif
   else ifneq ($(findstring win,$(shell uname -s)),)
      platform = win
   endif
else ifneq (,$(findstring armv,$(platform)))
   ifeq (,$(findstring classic_,$(platform)))
      override platform += unix
   endif
else ifneq (,$(findstring rpi,$(platform)))
   override platform += unix
endif

ifneq ($(platform), osx)
   ifeq ($(findstring Haiku,$(shell uname -a)),)
      PTHREAD_FLAGS = -lpthread
   endif
endif

TARGET_NAME = stella


ifeq (,$(findstring msvc,$(platform)))
   CXXFLAGS += -std=c++20 -fno-rtti
   LIBS := -lm
else
   LIBS :=
endif

GIT_VERSION := " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
   CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

GET_STATIC_ARG=$(if $(filter $(shell $(CXX) -print-file-name=$1.a),$1.a),,-static-$1)
# Unix
ifneq (,$(findstring unix,$(platform)))
   GPP_MAJOR := $(shell $(CXX) -dumpversion | cut -d '.' -f 1)
   ifeq ($(GPP_MAJOR),)
      $(error Unable to determine $(CXX) version)
   endif
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) $(call GET_STATIC_ARG,libgcc) $(call GET_STATIC_ARG,libstdc++)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   ifneq ($(findstring SunOS,$(shell uname -a)),)
      CXX = g++
      SHARED := -shared -z defs
   else
      SHARED := -shared -Wl,--version-script=link.T -Wl,-z,defs
   endif

   # ARM
   ifneq (,$(findstring armv,$(platform)))
      CXXFLAGS += -DARM
   # Raspberry Pi
   else ifneq (,$(findstring rpi,$(platform)))
      CXXFLAGS += -DARM
   endif

# OS X
else ifeq ($(platform), osx)
   CXXFLAGS += $(LTO) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION :=
   arch = intel
   ifeq ($(shell uname -p),powerpc)
      arch = ppc
   endif
   ifeq ($(arch),ppc)
      CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   endif
   fpic += $(MINVERSION)

   ifeq ($(CROSS_COMPILE),1)
      TARGET_RULE   = -target $(LIBRETRO_APPLE_PLATFORM)
   else
      TARGET_RULE   = -target x86_64-apple-macos10.13
   endif
   CFLAGS   += $(TARGET_RULE)
   CPPFLAGS += $(TARGET_RULE)
   CXXFLAGS += $(TARGET_RULE)
   LDFLAGS  += $(TARGET_RULE)

   CFLAGS    += $(ARCHFLAGS)
   CXXFLAGS  += $(ARCHFLAGS)
   LDFLAGS   += $(ARCHFLAGS)

# iOS
else ifneq (,$(findstring ios,$(platform)))
   CXXFLAGS += $(LTO) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION :=
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
   endif
   ifeq ($(platform),ios-arm64)
      CC  = cc -arch arm64 -isysroot $(IOSSDK)
      CXX = c++ -arch arm64 -isysroot $(IOSSDK)
   else
      CC  = cc -arch armv7 -isysroot $(IOSSDK)
      CXX = c++ -arch armv7 -isysroot $(IOSSDK)
   endif
   CXXFLAGS += -DIOS -DARM -fno-aligned-allocation
   ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
      MINVERSION = -miphoneos-version-min=8.0
   else
      MINVERSION = -miphoneos-version-min=5.0
   endif
   CXXFLAGS += $(MINVERSION)

# tvOS
else ifeq ($(platform), tvos-arm64)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS) -stdlib=libc++
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   ifeq ($(IOSSDK),)
      IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
   endif
   CXXFLAGS += -DIOS
   CXXFLAGS += -DARM

   CC  = cc -arch arm64 -isysroot $(IOSSDK)
   CXX = c++ -arch arm64 -isysroot $(IOSSDK)

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
   include $(DEVKITPRO)/libnx/switch_rules
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   DEFINES := -DSWITCH=1 -D__SWITCH__ -DARM
   CXXFLAGS += $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -specs=$(LIBNX)/switch.specs
   CXXFLAGS += -march=armv8-a -mtune=cortex-a57 -mtp=soft -mcpu=cortex-a57+crc+fp+simd -ffast-math $(ASFLAGS)
   STATIC_LINKING = 1

# Classic Platforms ####################
# Platform affix = classic_<ISA>_<µARCH>
# Help at https://modmyclassic.com/comp

# (armv7 a7, hard point, neon based) ###
# NESC, SNESC, C64 mini
else ifeq ($(platform), classic_armv7_a7)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T -Wl,--no-undefined
   CXXFLAGS += -Ofast \
               -flto=4 -fwhole-program -fuse-linker-plugin \
               -fdata-sections -ffunction-sections -Wl,--gc-sections \
               -fno-stack-protector -fno-ident -fomit-frame-pointer \
               -falign-functions=1 -falign-jumps=1 -falign-loops=1 \
               -fno-unwind-tables -fno-asynchronous-unwind-tables -fno-unroll-loops \
               -fmerge-all-constants -fno-math-errno \
              -marm -mtune=cortex-a7 -mfpu=neon-vfpv4 -mfloat-abi=hard
   HAVE_NEON = 1
   ARCH = arm
   BUILTIN_GPU = neon
   USE_DYNAREC = 1
   ifeq ($(shell echo `$(CXX) -dumpversion` "< 4.9" | bc -l), 1)
      CXXFLAGS += -march=armv7-a
   else
      CXXFLAGS += -march=armv7ve
      # If gcc is 5.0 or later
      ifeq ($(shell echo `$(CXX) -dumpversion` ">= 5" | bc -l), 1)
         LDFLAGS += -static-libgcc -static-libstdc++
      endif
   endif


# Theos
else ifeq ($(platform), theos_ios)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   DEPLOYMENT_IOSVERSION = 5.0
   TARGET = iphone:latest:$(DEPLOYMENT_IOSVERSION)
   ARCHS = armv7 armv7s
   TARGET_IPHONEOS_DEPLOYMENT_VERSION=$(DEPLOYMENT_IOSVERSION)
   THEOS_BUILD_DIR := objs
   include $(THEOS)/makefiles/common.mk
   LIBRARY_NAME = $(TARGET_NAME)_libretro_ios

# QNX
else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   SHARED := -shared -Wl,--version-script=link.T
   CXX = QCC -Vgcc_notarmv7le
   AR = QCC -Vgcc_ntoarmv7le
   CXXFLAGS += -D__BLACKBERRY_QNX__
   CXXFLAGS += -DARM
   HAVE_EXCEPTIONS = 1

# Vita
else ifeq ($(platform), vita)
   CXXFLAGS += $(LTO) $(PTHREAD_FLAGS)
   LDFLAGS += $(LTO) $(PTHREAD_FLAGS)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   CXX = arm-vita-eabi-g++$(EXE_EXT)
   AR = arm-vita-eabi-ar$(EXE_EXT)
   CXXFLAGS += -DVITA
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   HAVE_EXCEPTIONS = 1

# PS3
else ifneq (,$(filter $(platform), ps3 sncps3 psl1ght))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXXFLAGS += -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   STATIC_LINKING = 1
   HAVE_STRINGS_H = 0

   # sncps3
   ifneq (,$(findstring sncps3,$(platform)))
      TARGET := $(TARGET_NAME)_libretro_ps3.a
      CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
      AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
   # PS3
   else ifneq (,$(findstring ps3,$(platform)))
      CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
      AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
   # Lightweight PS3 Homebrew SDK
   else ifneq (,$(findstring psl1ght,$(platform)))
      CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
      AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   endif

# CTR (3DS)
else ifeq ($(platform), ctr)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITARM)/bin/arm-none-eabi-g++$(EXE_EXT)
   AR = $(DEVKITARM)/bin/arm-none-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES := -DLSB_FIRST
   CXXFLAGS += -DARM11 -D_3DS
   CXXFLAGS += -march=armv6k -mtune=mpcore -mfloat-abi=hard
   CXXFLAGS += -mword-relocations
   CXXFLAGS += -fomit-frame-pointer -fstrict-aliasing -ffast-math
   CXXFLAGS += -fno-rtti
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1
   LOAD_FROM_MEMORY = 0

# Xbox 360
else ifeq ($(platform), xenon)
   CXXFLAGS += $(LTO)
   LDFLAGS += $(LTO)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   CXXFLAGS += -D__LIBXENON__ -m32 -D__ppc__
   LIBS := $(PTHREAD_FLAGS)
   STATIC_LINKING = 1

# Nintendo Game Cube / Wii / WiiU
else ifneq (,$(filter $(platform), ngc wii wiiu))
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   CXXFLAGS += -mcpu=750 -meabi -mhard-float -DBLARGG_BIG_ENDIAN=1 -D__ppc__
   CXXFLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int
   STATIC_LINKING = 1

   # Nintendo WiiU
   ifneq (,$(findstring wiiu,$(platform)))
      CXXFLAGS += -mwup
   # Nintendo Wii
   else ifneq (,$(findstring wii,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   # Nintendo Game Cube
   else ifneq (,$(findstring ngc,$(platform)))
      CXXFLAGS += -DGEKKO -mrvl
   endif

# Emscripten
else ifeq ($(platform), emscripten)
   TARGET := $(TARGET_NAME)_libretro_$(platform).bc
   STATIC_LINKING = 1
   CXXFLAGS += $(PTHREAD_FLAGS) -std=c++20
   LDFLAGS += $(PTHREAD_FLAGS) -std=c++20

# Genode
else ifeq ($(platform), genode)
   TARGET  := $(TARGET_NAME)_libretro.lib.so
   PKG_CONFIG := genode-lib genode-stdcxx
   CXXFLAGS += -D__GENODE__
   CXXFLAGS += $(shell pkg-config --cflags $(PKG_CONFIG))

   LDFLAGS += -shared --version-script=link.T
   LDFLAGS += $(shell pkg-config --libs $(PKG_CONFIG))

   CXX = $(shell pkg-config genode-base --variable=cxx)
   LD  = $(shell pkg-config genode-base --variable=ld)
   AR  = $(shell pkg-config genode-base --variable=ar) -rcs

# Windows MSVC 2003 Xbox 1
else ifeq ($(platform), xbox1_msvc2003)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk1.lib
   MSVCBINDIRPREFIX = $(XDK)/xbox/bin/vc71
   CXX  = "$(MSVCBINDIRPREFIX)/CL.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XDK)/xbox/include
   export LIB := $(XDK)/xbox/lib
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX1
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2010 Xbox 360
else ifeq ($(platform), xbox360_msvc2010)
   CXXFLAGS += -D__WIN32__
   TARGET := $(TARGET_NAME)_libretro_xdk360.lib
   MSVCBINDIRPREFIX = $(XEDK)/bin/win32
   CXX  = "$(MSVCBINDIRPREFIX)/cl.exe"
   LD   = "$(MSVCBINDIRPREFIX)/lib.exe"

   export INCLUDE := $(XEDK)/include/xbox
   export LIB := $(XEDK)/lib/xbox
   PSS_STYLE :=2
   CXXFLAGS += -D_XBOX -D_XBOX360
   STATIC_LINKING=1
   HAS_GCC := 0

# Windows MSVC 2017 all architectures
else ifneq (,$(findstring windows_msvc2017,$(platform)))
   CXXFLAGS += -D__WIN32__

   PlatformSuffix = $(subst windows_msvc2017_,,$(platform))
   ifneq (,$(findstring desktop,$(PlatformSuffix)))
      WinPartition = desktop
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_DESKTOP_APP
      LDFLAGS += -MANIFEST -LTCG:incremental -NXCOMPAT -DYNAMICBASE -DEBUG -OPT:REF -INCREMENTAL:NO -SUBSYSTEM:WINDOWS -MANIFESTUAC:"level='asInvoker' uiAccess='false'" -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1
      LIBS += kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib
   else ifneq (,$(findstring uwp,$(PlatformSuffix)))
      WinPartition = uwp
      MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_APP -D_WINDLL -D_UNICODE -DUNICODE -D__WRL_NO_DEFAULT_LIB__ -ZW:nostdlib -EHsc
      LDFLAGS += -APPCONTAINER -NXCOMPAT -DYNAMICBASE -MANIFEST:NO -LTCG -OPT:REF -SUBSYSTEM:CONSOLE -MANIFESTUAC:NO -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1 -DEBUG:FULL -WINMD:NO
      LIBS += WindowsApp.lib
   endif

   # Specific to this core

=== debian/changelog ===
stella (7.0+dfsg-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Add cross.patch prepending _host_prefix to pkg-config.
    Closes: #1094710.

  [ Stephen Kitt ]
  * debian/rules: switch to execute_after/before.

 -- Stephen Kitt <skitt@debian.org>  Fri, 31 Jan 2025 08:32:49 +0100

stella (7.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Enable parallel linking with LTO.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 06 Oct 2024 15:48:32 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: stella
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Stephen Kitt <skitt@debian.org>
 Section: otherosfs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               libgtest-dev,
                libpng-dev,
                libsdl2-dev,
                libsqlite3-dev,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/games-team/stella
 Vcs-Git: https://salsa.debian.org/games-team/stella.git
 Homepage: https://stella-emu.github.io

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  CPUS := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
else
  CPUS := auto
endif
export DEB_CXXFLAGS_MAINT_APPEND = -flto=$(CPUS)
export DEB_LDFLAGS_MAINT_APPEND = -flto=$(CPUS)

include /usr/share/dpkg/architecture.mk

%:
	dh $@

execute_before_dh_auto_clean:
# Generate the minimal config.mak required for "make distclean"
	test -f config.mak || echo "RM_REC := rm -f -r" > config.mak

override_dh_auto_configure:
	./configure --prefix=/usr $(if $(filter $(DEB_BUILD_ARCH),$(DEB_HOST_ARCH)),,--host=$(DEB_HOST_GNU_TYPE)) --enable-release

execute_after_dh_auto_install:
# This is also installed as the upstream changelog
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/Changes.txt
# This is overridden by the copyright file
	rm $(CURDIR)/debian/stella/usr/share/doc/stella/License.txt
